class Settings::BenchmarkConfigurationsController < SettingsController
  def index
    @benchmark_configuration = BenchmarkConfiguration.new
  end

  def show
    @benchmark_configuration = BenchmarkConfiguration.find(params[:id])
  end

  def create
    @benchmark_configuration = BenchmarkConfiguration.new(benchmark_configuration_params) 

    if @benchmark_configuration.save
      flash[:success] = "Configuration #{@benchmark_configuration.name} successfully created"
      redirect_to action: :index
    else
      flash.now[:failure] = "There were some errors" 
      render "index"
    end
  end

  def update
    if @benchmark_configuration.update_attributes(benchmark_configuration_params)
      flash[:success] = "Configuration #{@benchmark_configuration.name} successfully updated"
      redirect_to action: :index
    else
      flash.now[:failure] = "There were some errors" 
      render "show"
    end
  end

  def destroy
    @benchmark_configuration = BenchmarkConfiguration.find(params[:id])

    if @benchmark_configuration.destroy
      flash[:success] = "Configuration #{@benchmark_configuration.name} successfully deleted"
    else
      flash[:error] = "Could not delete #{@benchmark_configuration.name} configuration"
    end

    redirect_to action: :index
  end

  private

  def benchmark_configuration_params
    strong_params = params.require(:benchmark_configuration).permit(:runtime_id, :operating_system_id)
    strong_params.merge(language_id: Runtime.find(strong_params[:runtime_id]).language.id)
  end
end
